%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Ref_Dir_Origin, Ref_Dir_Vector] = Get_Reference_Direction(Fastener_Index, Layer, Axis_Point_1, Axis_Point_2, Axis_vector)

global ErrCode;

global DB_FASTENERS;

global DB_MPC;
global DB_NODES;

global AT_MPC;
global AT_NODES;

global Ref_Dir_Vector_zero_tolerance;

Ref_Dir_Origin = [];
Ref_Dir_Vector = [];

% Нахождение референсной точки на присоединенной сетке

switch DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}

    case 'plate'

        Elm_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
        
        Node_list = Get_Nodes_From_Elements(Elm_list, DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer));
        
    case 'plate_rbe2_sequential'
        
        Elm_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
        
        Node_list = Get_Nodes_From_Elements(Elm_list, []);
        
        [Test_Result, Center_Node_ID] = Plate_RBE2_Seq_Centered_Test(Fastener_Index, Layer);
        
        if (ErrCode < 0)
            return;
        end
        
        switch Test_Result
            case 1
                Excluded_nodes = Center_Node_ID;
            case 0
                Excluded_nodes = [];
            case -1
                Excluded_nodes = Center_Node_ID;
            otherwise
                fprintf (1, '\nОшибка функции Get_Reference_Direction: неожиданное значение параметра Test_Result в болте %i !\n', Fastener_Index);
                ErrCode = -1;
                return;
        end
        
        Node_list = setdiff(Node_list, Excluded_nodes);
        
    case 'plate_rbe2_parallel'
        
        Elm_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
        
        Node_list = Get_Nodes_From_Elements(Elm_list, DB_FASTENERS{Fastener_Index}.Joint_nodes(Layer));

    case {'rbe2_2d_hole', 'rbe2_3d_hole'}
        
        Node_list = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.MPC_ID)}.dep_grid;
        
        Elm_list = Get_Elements_From_Nodes(Node_list, []);
        
        Node_list = Get_Nodes_From_Elements(Elm_list, Node_list);

    case {'bar_spider_2d_hole', 'bar_spider_3d_hole'}
        
        Node_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Bar_Spider_Conn_Nodes_list;
        
        Elm_list = Get_Elements_From_Nodes(Node_list, DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Bar_Spider_Elm_list);
        
        Node_list = Get_Nodes_From_Elements(Elm_list, Node_list);

    otherwise

        fprintf (1, '\nОшибка функции Get_Reference_Direction: неизвестный тип присоединенной топологии [%s] в болте %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
        ErrCode = -1;
        return;

end

if (isempty(Node_list))
    fprintf (1, '\nНеожиданная ошибка функции Get_Reference_Direction: пустой список Node_list в болте %i !\n', Fastener_Index);
    ErrCode = -1;
    return;
end

Node_list = sortrows(Node_list,1);

Ref_Mesh_Point = DB_NODES{AT_NODES(Node_list(1))}.Location;

% Нахождение референсной точки на болте
Ref_Dir_Origin = Get_Plate_Midsurf_Point(Fastener_Index, Layer, Axis_Point_1, Axis_Point_2, Axis_vector);

if (ErrCode < 0)
    return;
end

% Проверка точек
if (Equiv_Check_Cube(Ref_Dir_Origin, Ref_Mesh_Point))
    fprintf (1, '\nНеожиданная ошибка функции Get_Reference_Direction: обнаружены совпадающие референсные точки в болте %i !\n', Fastener_Index);
    ErrCode = -1;
    return;
end

% Получение отсчетного направления
Ref_Dir_Vector = cross(Ref_Mesh_Point - Ref_Dir_Origin, Axis_vector);

if (norm(Ref_Dir_Vector) < Ref_Dir_Vector_zero_tolerance)
    fprintf (1, '\nОшибка функции Get_Reference_Direction: недопустимая длина референсного вектора !\n');
    ErrCode = -1;
    return;
end

Ref_Dir_Vector = Ref_Dir_Vector / norm(Ref_Dir_Vector);
